const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Inventory_eventsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const inventory_events = await db.inventory_events.create(
      {
        id: data.id || undefined,

        event_type: data.event_type || null,
        timestamp: data.timestamp || null,
        metadata: data.metadata || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await inventory_events.setDevice(data.device || null, {
      transaction,
    });

    await inventory_events.setOrganizations(data.organizations || null, {
      transaction,
    });

    return inventory_events;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const inventory_eventsData = data.map((item, index) => ({
      id: item.id || undefined,

      event_type: item.event_type || null,
      timestamp: item.timestamp || null,
      metadata: item.metadata || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const inventory_events = await db.inventory_events.bulkCreate(
      inventory_eventsData,
      { transaction },
    );

    // For each item created, replace relation files

    return inventory_events;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const inventory_events = await db.inventory_events.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.event_type !== undefined)
      updatePayload.event_type = data.event_type;

    if (data.timestamp !== undefined) updatePayload.timestamp = data.timestamp;

    if (data.metadata !== undefined) updatePayload.metadata = data.metadata;

    updatePayload.updatedById = currentUser.id;

    await inventory_events.update(updatePayload, { transaction });

    if (data.device !== undefined) {
      await inventory_events.setDevice(
        data.device,

        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await inventory_events.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return inventory_events;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const inventory_events = await db.inventory_events.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of inventory_events) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of inventory_events) {
        await record.destroy({ transaction });
      }
    });

    return inventory_events;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const inventory_events = await db.inventory_events.findByPk(id, options);

    await inventory_events.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await inventory_events.destroy({
      transaction,
    });

    return inventory_events;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const inventory_events = await db.inventory_events.findOne(
      { where },
      { transaction },
    );

    if (!inventory_events) {
      return inventory_events;
    }

    const output = inventory_events.get({ plain: true });

    output.device = await inventory_events.getDevice({
      transaction,
    });

    output.organizations = await inventory_events.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.devices,
        as: 'device',

        where: filter.device
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.device
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  serial: {
                    [Op.or]: filter.device
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.metadata) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'inventory_events',
            'metadata',
            filter.metadata,
          ),
        };
      }

      if (filter.timestampRange) {
        const [start, end] = filter.timestampRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            timestamp: {
              ...where.timestamp,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            timestamp: {
              ...where.timestamp,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.event_type) {
        where = {
          ...where,
          event_type: filter.event_type,
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.inventory_events.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('inventory_events', 'event_type', query),
        ],
      };
    }

    const records = await db.inventory_events.findAll({
      attributes: ['id', 'event_type'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['event_type', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.event_type,
    }));
  }
};
